INCDIR   = ../include

# --- Include files ---
INCFLGS = -I/usr/local/include -I$(INCDIR)

# --- System ---
SYSFLGS =  -Wall

# --- Debug ---
DEBUGFLAGS  = -g
#OPTFLAGS   = -O2 -DNDEBUG
CFLAGS      = $(INCFLGS) $(SYSFLGS) $(DEBUGFLAGS) $(OPTFLAGS)

SYS_LIBS      =
LOCAL_LIBS    = ../lib/libossec.a

LDLIBS      = $(SYS_LIBS) $(LOCAL_LIBS)
LDOPTIONS   = -lcrypto -lOpenSOAPClient -Wl,-rpath -Wl,/usr/local/lib

RM  = rm -f
CC  = gcc

OBJS1   = genkey.o
OBJS2   = envelopeTst.o fio.o

HEADERS =
PROG1   = genrsakey
PROG2   = secEnv

.c.o:
	$(CC) $(CFLAGS) -c $<

all: $(PROG1) $(PROG2)

$(PROG1): $(OBJS1) $(HEADERS) $(LOCAL_LIBS)
	$(CC) -o $@ $(OBJS1) $(LDLIBS) $(LDOPTIONS)

$(PROG2): $(OBJS2) $(HEADERS) $(LOCAL_LIBS)
	$(CC) -o $@ $(OBJS2) $(LDLIBS) $(LDOPTIONS)

clean:
	$(RM) $(PROG1) $(OBJS1) $(PROG2) $(OBJS2) *.bak *~

depend :
	makedepend -I$(INCDIR) *.c

