/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: CStdio.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef OpenSOAP_IMPL_CStdio_H
#define OpenSOAP_IMPL_CStdio_H

#include "Stream.h"

#include <stdio.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */
    
    typedef struct tagOpenSOAPCStdio OpenSOAPCStdio;
    typedef OpenSOAPCStdio    *OpenSOAPCStdioPtr;
    
    struct tagOpenSOAPCStdio {
        OpenSOAPStream  super;
        FILE    *inputStream;
        FILE    *outputStream;
    };

    int
    OPENSOAP_API
    OpenSOAPCStdioCreate(OpenSOAPCStdioPtr * /* [out] */ s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioCreateWithFILEPtr(FILE * /* [in] */ is,
                                    FILE * /* [in] */ os,
                                    OpenSOAPCStdioPtr * /* [out] */ s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioCreateForStdio(OpenSOAPCStdioPtr * /* [out] */ s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioClose(OpenSOAPCStdioPtr /* [in] */ s);

    int
    OPENSOAP_API
    OpenSOAPCStdioRelease(OpenSOAPCStdioPtr /* [in] */ s);

    int
    OPENSOAP_API
    OpenSOAPCStdioSetBinaryMode(OpenSOAPCStdioPtr /* [in] */ s);
    
    int
    OPENSOAP_API
    OpenSOAPCStdioSetTextMode(OpenSOAPCStdioPtr /* [in] */ s);

    int
    OPENSOAP_API
    OpenSOAPCStdioRead(OpenSOAPCStdioPtr /* [in] */ s,
                       unsigned char * /* [out] */ buf,
                       size_t * /* [in, out] */ buf_sz);
    

    int
    OPENSOAP_API
    OpenSOAPCStdioWrite(OpenSOAPCStdioPtr /* [in] */ s,
                        const unsigned char * /* [in] */ buf,
                        size_t * /* [in, out] */ buf_sz);
    

    int
    OPENSOAP_API
    OpenSOAPCStdioReadToDelm(OpenSOAPCStdioPtr /* [in] */ s,
                             const unsigned char * /* [in] */ delm,
                             size_t /* [in] */ delm_sz,
                             OpenSOAPByteArrayPtr /* [out] */ buf);
    
#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* OpenSOAP_IMPL_CStdio_H */
