/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: DataRetainer.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef DataRetainer_H
#define DataRetainer_H

#include <string>
#include <map>

namespace OpenSOAP {

  class DataContainer;
  
  class DataRetainer {

  public:
    //--- Id class ---
    //IDNX
    //͕
    class Id {
    public:
      Id() {}
      Id(const std::string& id) : id_(id) {}
      ~Id() {}
      
      const std::string toString() const { return id_; }
      bool fromString(const std::string& id) { id_ = id; return isValid(); }

      bool isValid() const { return (id_.empty() || INVALID == id_) ?
			       false : true; }
      
      static const std::string INVALID; // = "<invalid>"

    protected:
      std::string id_;
    };
    //--- End Id class ---

    //typedef std::string Id;

    //static const std::string ID_NONE; // = "<none>"

  public:
    //DataRetainer();
    DataRetainer(const std::string& saveDir);
    DataRetainer(const std::map<int, std::string>& attr);
    virtual ~DataRetainer();

    enum ATTR_TYPE {
      SAVE_DIR = 1,
      ID_PREFIX,
    };

    //Kvȑ̐ݒ
    //(P)FileRetaineȑꍇ͕ێfBNgpX
    //(Q)DBRetaineȑꍇDB[UID,DBpX[h,e[u
    //(R)SHMRetainer̋LZOgL[,LTCY
    //virtual int setAttributes(const std::vector<string>& attr);
    virtual int setAttributes(const std::map<int, std::string>& attr);

    //    virtual int write(DataContainer& dataCont);
    //    virtual int read(DataContainer& dataCont);
    //f[^ۑ
    virtual int put(DataContainer& dataCont);
    //f[^㏑
    virtual int update(DataContainer& dataCont);
    //f[^ǂݏo
    virtual int get(DataContainer& dataCont);
    //f[^폜
    virtual int del(const Id& id);
    //f[^ǂݏo폜
    virtual int delget(DataContainer& dataCont);
    //f[^݃`FbN
    virtual bool exists(const Id& id);
    
  protected:
    //̎_ł̃VXeԂt@CƂID擾
    const Id getNewId();
	
#if 0
  //b܂łƂPbȓɕ̏ꍇɏd邽
  //̂ƂɂT̃V[PXԍtB
  //V[PXԍIDsɃJEgAbv99999ȏłOɖ߂B
#endif
    
    std::map<int, std::string> attributes_;
    std::string saveDir_;

  };

  class DataContainer {
  public:
    DataContainer() {}
    DataContainer(const DataRetainer::Id& id) : id_(id) {}
    DataContainer(const std::string& data) : data_(data) {}
    virtual ~DataContainer() {}
    
    const DataRetainer::Id& getId() const { return id_; }
    const std::string& getData() const { return data_; }
    
    void setId(const DataRetainer::Id& id) { id_ = id; }
    void setData(const std::string& data) { data_ = data; }

  protected:
    DataRetainer::Id id_;
    std::string data_;
  };


} // end of namespace OpenSOAP


#endif /* DataRetainer_H */
