/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: FIFOSrvDrv.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef FIFO_SRV_DRV_H
#define FIFO_SRV_DRV_H

#include <string>
#include <vector>

#include <pthread.h>

namespace OpenSOAP {
  class ChannelDescriptor;

  class FIFOSrvDrv {
  private:
    pthread_mutex_t _mt;
    
    bool _isAsync;
    ChannelDescriptor chnlDesc_;
    
    std::string soapMsgFromMsgdrv;
    std::string soapMsgFromService;
    
    std::string fileIDOfMsgFromMsgdrv;
    std::string fileIDOfMsgFromService;
    
    unsigned int downside_timeout, ttl;
    
  private:
    //----- [JœIy[Vs߂̃Xbh  -----//
    static void* 
    localSyncThrFunc (void* arg);
    
    //----- [J̓Iy[Vs -----//
    bool
    execLocalSyncOperation();
    
    //----- 񓯊̏ꍇ̃X|Xs -----//
    bool asyncResponse();
    
  public:
    FIFOSrvDrv(const ChannelDescriptor& chnlDesc);
    ~FIFOSrvDrv();
    
    void run();
    void setAsyncFlag(bool isAsync);
  };
  
}

#endif /* FIFO_SRV_DRV_H */
