/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: Forwarder.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef FORWARDER_H
#define FORWARDER_H

#include <string>
#include <vector>
#include <pthread.h>

namespace OpenSOAP {

  class ChannelDescriptor;

  class Forwarder {
    
  private:
    pthread_mutex_t _mt;
    
    std::string localhostName;
    std::string backwardURL;
    
    bool defaultForwarding;
    std::string forwardHostname;
    unsigned int forwardPort;
    std::string forwardCGILocation;
    
    std::vector<std::string> prtcls;
    std::vector<std::string> hostnames;
    std::vector<unsigned int> ports;
    std::vector<std::string> cgiLocations;
    
    std::string operationName;
    
    ChannelDescriptor chnlDesc_;
    
    std::string soapMsgFromMsgDrv;
    std::string soapMsgFromOtherIf;
    std::string fileIDOfMsgFromMsgDrv;
    std::string fileIDOfMsgFromOtherIf;
    unsigned int ttl;
  private:
    //----- bZ[W]Xbh -----//
    static void* syncMessageForward(void* arg);

    //----- bZ[W] -----//
    bool execSyncMessageForward();
    
    //----- tH[hzXg̏               -----//
    //----- SOAP Header  forward_path 擾 -----//
    bool setFwdHostInfo();
    
    //----- 2 ڈȍ~̃zXgł, received_path ǉ ------//
    bool addReceivedPath ();
    
    //----- TTL Table 烁bZ[W ID ɑΉ -----/
    //----- backward_path T -----/
    bool refToTTLTable(const std::string& msgIDContent, 
		       std::string& backwardPath);
    
    //----- X|X߂s -----//
    bool execBackwarding();
    
  public:
    Forwarder(const ChannelDescriptor& chnlDesc);
    
    ~Forwarder();
    void run();
  };
}
#endif /* FORWARDER_H */
