/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: InetSocketSrvDrv.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef INET_SOCKET_SRV_DRV_H
#define INET_SOCKET_SRV_DRV_H

#include <string>
#include <vector>

#include <pthread.h>

namespace OpenSOAP {
  class ChannelDescriptor;
  class SSMLInfo;
  
  class InetSocketSrvDrv {
  private:
    pthread_mutex_t _mt;
    SSMLInfo ssmlInfo;
    
    bool _isAsync;
    bool _itIsAsyncFwdFinalReceiver;
    ChannelDescriptor chnlDesc_;
    
    std::string soapMsgFromMsgdrv;
    std::string soapMsgFromService;
    
    std::string fileIDOfMsgFromMsgdrv;
    std::string fileIDOfMsgFromService;
    
    unsigned int downside_timeout, ttl;
    
    std::string localhostname;
    
    std::vector<std::string> localURLs;
  private:
    //----- [JœIy[Vs߂̃Xbh  -----//
    static void* 
    localSyncThrFunc (void* arg);
    
    //----- [J̓Iy[Vs -----//
    bool
    execLocalSyncOperation();
    
    //----- 񓯊̏ꍇ̃X|Xs -----//
    bool asyncResponse();
    
    //----- 񓯊]̍ŏIT[o[̏ꍇ̃X|Xs -----//
    bool asyncFwdResponse();
  public:
    InetSocketSrvDrv(const ChannelDescriptor& chnlDesc);
    ~InetSocketSrvDrv();
    
    void run();
    void setAsyncFlag(bool isAsync);
  };
  
}

#endif /* INET_SOCKET_SRV_DRV_H */
