/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: MapUtil.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef MapUtil_H
#define MapUtil_H

#include <string>
#include <map>

namespace OpenSOAP {

  class MapUtil : public std::map<std::string, std::string> {
  public:
    MapUtil(const std::string& itemDelimit, 
	    const std::string& keyValDelimit);
    ~MapUtil();

    void insertItem(const std::string& data);
    bool exists(const std::string& key) const;
    std::string toString() const;

    void spy() const;

  private:
    void insertMap(const std::string& item);

    std::string itemDelimit_;
    std::string keyValDelimit_;
  };

} // end of namespace OpenSOAP

#endif /* MapUtil_H */
