/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: MsgDrvCreator_main.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#include <unistd.h>

#include <cstdio>
#include <fstream>
#include <string>

#include "ServerCommon.h"
#include "MsgDrvCreator.h"

using namespace OpenSOAP;

int
main(int argc, char** argv) {
  // make it to daemon & write pid file
#if HAVE_DAEMON
  daemon(0, 1);
#endif
  
  pid_t pid = getpid();
  
  ofstream pidFile(MSGDRV_PID_FILE.c_str());
  if (!pidFile) {
    cerr << "Error: pid file [" 
	 << MSGDRV_PID_FILE << "] cannot open!" << endl;
    exit(1);
  }
  pidFile << pid;
  pidFile.close();
  
  // create instance of Message Driver and run  
  ChannelManager* chnlMngr = new MsgDrvCreator();
  //chnlMngr->setSocketAddr("/var/tmp/OpenSOAP/SOCKET/msgDrvCreator");
  chnlMngr->setMask(0x000);
  chnlMngr->run();
  
  delete chnlMngr;
  
  return EXIT_SUCCESS;
}
