/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SSMLAttrMgr.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef SSMLAttrMgr_H
#define SSMLAttrMgr_H

#include <string>
#include <pthread.h>
#include <list>
//#include <tree.h>
//#include <parser.h>

namespace OpenSOAP {

  class SSMLAttrMgr {

    static const std::string SSML_FILE_SUFFIX; // = "txt";

  public:
    //UNIXhC\Pbg̃AhXXMLt@CfBNgw肷
    SSMLAttrMgr(const std::string& socketAddr, const std::string& xmlDir);
    virtual ~SSMLAttrMgr();

    //ʐMJn
    int run();

    //int 

  private:
    //f[^̃[h̃bN
    pthread_mutex_t loadXmlLock_;
    //pthread_cond_t  ;

    //UNIXhC\PbgAhX
    std::string socketAddr_;

    //ǂݍݑΏXMLt@CfBNg
    std::string xmlDir_;

    //DOMf[^̃Xg
    std::list<xmlDocPtr> xmlList_;

    //XMLt@C̓ǂݍ
    int loadXml();

    //ʐM
    static void* connectionThread(void* arg);
    void connectProc(int sockfd);

    //for shm buffer
    void clearShm();
    void addShm(const std::string& query, const std::string& value);
    int semid_; // SEM ID

    //  public: // for test
    std::string queryXml(const std::string& query);

    typedef struct ThrDataTag {
      SSMLAttrMgr* that;
      int sockfd;
    } ThrData;
  };

} // end of namespace OpenSOAP


#endif /* SSMLAttrMgr_H */
