/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SSMLAttrMgr_main.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <fstream>
#include <string>
#include "ServerCommon.h"
#include "XmlQuery.h"
#include "SSMLAttrMgr.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>


//#define TEST

using namespace OpenSOAP;

int 
main(int argc, char** argv)
{
  // make it to daemon & write pid file
#if HAVE_DAEMON
  daemon(0, 1);
#endif
  
  pid_t pid = getpid();
  
  ofstream pidFile(SSMLATTRMGR_PID_FILE.c_str());
  if (!pidFile) {
    cerr << "Error: pid file [" 
	 << SSMLATTRMGR_PID_FILE << "] cannot open!" << endl;
    exit(1);
  }
  pidFile << pid;
  pidFile.close();
  
#ifdef TEST
  //std::string query = "/SSML,name=Calc/service,name=Calc/connection,name=SatoCalc3/synchronizedTTL=??";
  //std::string query = "/SSML,name=Calc2/service,name=Calc2/connection,name=SatoCalc3/synchronizedTTL=??";

  //std::string query = "/SSML,name=?"; //OK!!
  //std::string query = "/SSML,xmlns=?"; //NG
  //std::string query = "/SSML,xxx=?"; //NG
  //std::string query = "/SSML,name=Calc/service,name=?"; // OK!!
  //std::string query = "/SSML,name=Calc/service,name=Calc/connection,name=??"; //OK

  if (1 < argc) {
    query = argv[1];
  }

#if 0
  XmlQuery xmlQuery(query);

  xmlQuery.spy();

#else


  //std::string dirpath = "/home/chaya/work/OpenSOAP/server/SSMLAttrMgr/ssml";
  //std::string dirpath = "../ssml";
  std::string dirpath = "/var/tmp/OpenSOAP/conf/ssml";

  SSMLAttrMgr ssmlMgr("/var/tmp/OpenSOAP/SOCKET/SSMLAttrMgr", dirpath);

  std::string result = ssmlMgr.queryXml(query);

  cerr << "query result=[" << result << "]" << endl;

#endif

#endif TEST

  SSMLAttrMgr ssmlMgr(SSMLATTRMGR_SOCKET_ADDR, "/var/tmp/OpenSOAP/conf/ssml");
  ssmlMgr.run();

  return 0;
}
    
  
