/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ServerCommon.h,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#ifndef ServerCommon_H
#define ServerCommon_H

#include <string>

namespace OpenSOAP {

  // for LOG
  static const std::string TAG_ERR = "*** E ***:";
  static const std::string TAG_WRN = "*** W ***:";
  static const std::string TAG_INF = "*** I ***:";

  //keyword
  //static const std::string FILE_PATH_DELMIT = "/";
  static const char FILE_PATH_DELMIT = '/';

  //-------------------------------------------
  //ʊ֐
  //lbg[Nread/writeC^[tF[X(Socket/FIFO)
  int read(int aFd, std::string& aData);
  int write(int aFd, const std::string& aData);
  //-------------------------------------------

#if 1
  // path to temporal file directory
  static const std::string OPENSOAP_TMP_PATH = "/var/tmp/OpenSOAP/";
  
  // Socket Address 
  static const std::string MSGDRV_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/MsgDrv";
  
  static const std::string SYNC_SRVDRV_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/SyncSrvDrv";
  
  static const std::string ASYNC_SRVDRV_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/AsyncSrvDrv";
  
  static const std::string SRV_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/Srv";

  static const std::string FIFOSRV_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/FIFOSrv";

  static const std::string FWDER_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/Fwder";

  static const std::string IDMGR_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/IdManager";
  
  static const std::string SSMLATTRMGR_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/SSMLAttrMgr";
  
  static const std::string SRVCONFATTRMGR_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/SrvConfAttrMgr";
  
  static const std::string FWDQUEUE_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/FwdQueue";
  
  static const std::string REQQUEUE_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/ReqQueue";
  
  static const std::string RESSPOOL_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/ResSpool";
  
  static const std::string TTLMGR_SOCKET_ADDR 
  = OPENSOAP_TMP_PATH + "SOCKET/TTLManager";

  // PID File
  static const std::string MSGDRV_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/msgDrvCreator.pid";
  
  static const std::string SYNC_SRVDRV_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/srvDrvCreator_sync.pid";
  
  static const std::string ASYNC_SRVDRV_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/srvDrvCreator_async.pid";
  
  static const std::string SRV_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/Srv.pid";

  static const std::string FIFOSRV_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/FIFOSrv.pid";

  static const std::string FWDER_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/fwderCreator.pid";

  static const std::string IDMGR_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/idManager.pid";
  
  static const std::string SSMLATTRMGR_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/ssmlAttrMgr.pid";
  
  static const std::string SRVCONFATTRMGR_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/srvConfAttrMgr.pid";
  
  static const std::string FWDQUEUE_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/queueManager_fwd.pid";
  
  static const std::string REQQUEUE_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/queueManager_req.pid";
  
  static const std::string RESSPOOL_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/spoolManager.pid";
  
  static const std::string TTLMGR_PID_FILE 
  = OPENSOAP_TMP_PATH + "run/ttlManager.pid";
#else
  //temp.
  static const std::string MSGDRV_SOCKET_ADDR; 
  //=OPENSOAP_TMP_PATH + "SOCKET/MsgDrv";
  
  static const std::string SRVDRV_SOCKET_ADDR; 
  //=OPENSOAP_TMP_PATH + "SOCKET/SrvDrv";
  
  static const std::string IDMGR_SOCKET_ADDR; 
  //=OPENSOAP_TMP_PATH + "SOCKET/IdManager";
#endif

} // end of namespace OpenSOAP


#endif /* ServerCommon_H */
