/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: ServerCommon2.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */

#include <cstdio>
#include <unistd.h>

#include "ServerCommon2.h"

//using namespace OpenSOAP;

namespace OpenSOAP {

// for LOG
  const std::string TAG_ERR = "*** E ***:";
  const std::string TAG_WRN = "*** W ***:";
  const std::string TAG_INF = "*** I ***:";

  const std::string OPENSOAPROOT = "OPENSOAPROOT";

//keyword
const char FILE_PATH_DELMIT = '/';

// UNIX DOMAIN SOCKET ADDRESS
const std::string MSGDRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/MsgDrv";
const std::string SRVDRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/SrvDrv";
const std::string SRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/Srv";
const std::string FIFOSRV_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/FIFOSrv";
const std::string FWDER_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/Fwder";
const std::string IDMGR_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/IdManager";
const std::string SSMLATTRMGR_SOCKET_ADDR = "/var/tmp/OpenSOAP/SOCKET/SSMLAttrMgr";
const std::string SRVCONFATTRMGR_SOCKET_ADDR 
    = "/var/tmp/OpenSOAP/SOCKET/SrvConfAttrMgr";

//bZ[Wf~^
const std::string ITEM_DELMIT = "|";
const std::string SUB_ITEM_DELMIT = "!";
const std::string VAL_DELMIT = "=";
const std::string NODE_DELMIT = "/";
const std::string ATTR_DELMIT = ",";

//ėpbZ[W쐬L[[h
const std::string QUERY = "QUERY";
const std::string QUESTION_MARK = "?";
const std::string MULTI_QUESTION_MARK = "??";

//
const std::string CMD = "CMD";
const std::string RELOAD_XML = "RELOAD_XML";
const std::string SEARCH = "SEARCH";
const std::string RESULT = "RESULT";
const std::string SUCCESS = "SUCCESS";
const std::string FAILURE = "FAILURE";
const std::string RET_CODE = "RET_CODE";
const std::string ANSWER = "ANSWER";

//ChannelCommon.h
const std::string OPEN = "OPEN";
const std::string CLOSE = "CLOSE";
const std::string CHNL_TYPE = "CHNL_TYPE";
const std::string UNIX_SOCKET = "UNIX_SOCKET";
const std::string INET_SOCKET = "INET_SOCKET";
const std::string FIFO = "FIFO";
const std::string WAIT = "WAIT";
const std::string KEY_DELMIT = "=";

  //#include <cstdio>
  //#include <unistd.h>

  //namespace OpenSOAP {
//======== common function ==============
#if 0
int OpenSOAP::read(int fd, std::string& data)
{
  char readBuf[BUFSIZ];
  memset(readBuf, 0x00, sizeof(readBuf));
  ssize_t readLen = 0;
  data = "";

#if 0
  while (1) {
    readLen = std::read(fd, readBuf, sizeof(readBuf)-1);

    if (0 == readLen) {
#ifdef DEBUG
      cerr << "OpenSOAP::read 0 byte done." << endl;
#endif
      
      break;

    } 
    else if (0 > readLen) {
      cerr << TAG_ERR << "OpenSOAP::read failed" << endl;
      return -1;
    }

    readBuf[readLen] = 0x00;
    data += readBuf;

#ifdef DEBUG
    cerr << "OpenSOAP::read: [" << readBuf 
	 << "] len=(" << readLen << ")" << endl;
#endif

  }
#else // if 0
  readLen = std::read(fd, readBuf, sizeof(readBuf)-1);

  if (0 == readLen) {
#ifdef DEBUG
    cerr << "OpenSOAP::read 0 byte done." << endl;
#endif
      
  } 
  else if (0 > readLen) {
    cerr << TAG_ERR << "OpenSOAP::read failed" << endl;
    return -1;
  }

  readBuf[readLen] = 0x00;
  data += readBuf;

#ifdef DEBUG
  cerr << "OpenSOAP::read: [" << readBuf 
       << "] len=(" << readLen << ")" << endl;
#endif

#endif

  //return 0;
  return data.length();
}

int OpenSOAP::write(int fd, const std::string& data)
{
  char writeBuf[BUFSIZ];
  memset(writeBuf, 0x00, sizeof(writeBuf));
  ssize_t writeLen = 0;

  //std::string::size_type remainLen = data.length();
  int remainLen = data.length();

  while (remainLen > 0) {
    writeLen = std::write(fd, 
			  data.c_str()+(data.length() - remainLen), 
			  remainLen);
    
    if (0 > writeLen) {
      cerr << TAG_ERR << "OpenSOAP::write failed" << endl;
      return -1;
    } 
    else if (writeLen > remainLen) {
      cerr << "*** W ***:" << "OpenSOAP::write: invalid write length." << endl;
    }
    
    remainLen -= writeLen;
  }

  return data.length() - remainLen;
}
#endif //if 0

}


// End of ServerCommon.cpp
