/* -*- mode: c++; -*-
 *-----------------------------------------------------------------------------
 * $RCSfile: SpoolManager_main.cpp,v $
 *
 * See Copyright for the status of this software.
 *
 * The OpenSOAP Project
 * http://opensoap.jp/
 *-----------------------------------------------------------------------------
 */
#include <fstream>
#include <iostream>

#include <unistd.h>

#include "SpoolManager.h"
#include "ServerCommon.h"

using namespace OpenSOAP;

int
main (int argc, char* argv[])
{
  // make it to daemon & write pid file
#if HAVE_DAEMON
  daemon(0, 1);
#endif
  
  pid_t pid = getpid();
  
  ofstream pidFile(RESSPOOL_PID_FILE.c_str());
  if (!pidFile) {
    cerr << "Error: pid file [" 
         << RESSPOOL_PID_FILE << "] cannot open!" << endl;
    exit(1);
  }
  pidFile << pid;
  pidFile.close();

  
  // create instance of Spool Manager and run
  ChannelManager* spoolManagerPtr= new SpoolManager();
  spoolManagerPtr->run();
  delete spoolManagerPtr;
  
  return 0;
}// end of main (int, char**)
